summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJarkko Hietaniemi <jhi@iki.fi>2000-03-21 18:59:39 +0000
committerJarkko Hietaniemi <jhi@iki.fi>2000-03-21 18:59:39 +0000
commit2cae8c0d705cc1af2904974ee1f32be623629ff9 (patch)
tree74ade60414008af6fa29bc6d4afa69e8e5f1b8ec
parentdd858076e74b9b9d8ba6d968be8b63379f86a582 (diff)
downloadperl-2cae8c0d705cc1af2904974ee1f32be623629ff9.tar.gz
Disallow using too old gcc in {Tru64,Digital UNIX,DEC OSF/1}.
(Even gcc 2.95 doesn't seem to be working 100%.) p4raw-id: //depot/cfgperl@5860
-rw-r--r--hints/dec_osf.sh26
-rw-r--r--pod/perldelta.pod6
2 files changed, 31 insertions, 1 deletions
diff --git a/hints/dec_osf.sh b/hints/dec_osf.sh
index cba8db2f3b..db7b869cf2 100644
--- a/hints/dec_osf.sh
+++ b/hints/dec_osf.sh
@@ -65,7 +65,31 @@ cc=${cc:-cc}
# reset
_DEC_cc_style=
case "`$cc -v 2>&1 | grep cc`" in
-*gcc*) ;; # pass
+*gcc*) _gcc_version=`$cc -v 2>&1 | grep "gcc version" | sed 's%^gcc version \([0-9]*\)\.\([0-9]*\) .*%\1 \2%'`
+ set $_gcc_version
+ if test "$1" -lt 2 -o \( "$1" -eq 2 -a "$2" -lt 95 \); then
+ cat >&4 <<EOF
+
+Your cc seems to be gcc and its version seems to be less than 2.95.
+This is not a good idea since old versions of gcc are known to produce
+buggy code when compiling Perl (and no doubt for other programs, too).
+
+Therefore, I strongly suggest upgrading your gcc. (Why don't you
+use the vendor cc is also a good question. It comes with the operating
+system and produces good code.)
+
+Note that as of gcc 2.95 (19990728) and Perl 5.6.0 (end of March 2000)
+if the said Perl is compiled with the said gcc the lib/sdbm test will
+dump core. As this doesn't happen with the vendor cc, this is
+most probably a lingering bug in gcc. Therefore unless you have
+a better gcc you are still better off using the vendor cc.
+
+Cannot continue, aborting.
+
+EOF
+ exit 1
+ fi
+ ;;
*) # compile something small: taint.c is fine for this.
# the main point is the '-v' flag of 'cc'.
case "`cc -v -I. -c taint.c -o taint$$.o 2>&1`" in
diff --git a/pod/perldelta.pod b/pod/perldelta.pod
index f2f98d97c1..b9e81e972a 100644
--- a/pod/perldelta.pod
+++ b/pod/perldelta.pod
@@ -2678,6 +2678,12 @@ operating system libraries is buggy: the %j format numbers the days of
a month starting from zero, which, while being logical to programmers,
will cause the subtests 19 to 27 of the lib/posix test may fail.
+=head2 Tru64 (aka Digital UNIX, aka DEC OSF/1) lib/sdbm test failure with gcc
+
+If compiled with gcc 2.95 the lib/sdbm test will fail (dump core).
+The cure is to use the vendor cc, it comes with the operating system
+and produces good code.
+
=head2 UNICOS/mk CC failures during Configure run
In UNICOS/mk the following errors may appear during the Configure run: